/* Developed for Lenovo Educational Board Pass 2
   © Lenovo Created by Joshua Grosser
   v. 1.0 */
// include the following libraries
#include <WiFi.h>
#include <HTTPClient.h>
#include <Preferences.h>
Preferences preferences;
  
String ssid = "";
String password =  "";
// declare button pins
const int BUTTON = 1;
const int BUTTON2 = 2;
const int BUTTON3 = 3;
const int BUTTON4 = 4;

// get Wifi info
void getWifi()
{
  preferences.begin("credentials", false);
  ssid = preferences.getString("ssid", ""); 
  password = preferences.getString("password", "");
  if (ssid == "" || password == ""){
    Serial.println("No ssid or password saved.");
  }
  else {
    Serial.println("Successfully read WiFi information.");
  }
}

void setup() {
  // set baud rate
  Serial.begin(115200);
  delay(200);
  // connect to wifi
  getWifi();
  WiFi.begin(ssid.c_str(), password.c_str());
  Serial.println("Connecting to WiFi..");
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.print(".");
  }
  Serial.println();
  Serial.println("Connected to the WiFi network");
  // set pinModes for buttons to input
  pinMode(BUTTON, INPUT);
  pinMode(BUTTON2, INPUT);
  pinMode(BUTTON3, INPUT);
  pinMode(BUTTON4, INPUT);
}
  
void loop() {
  // if a button is pressed send a email, phone call, sms, or tweet
  if (digitalRead(BUTTON) == HIGH)
  {
    openURL("https://maker.ifttt.com/trigger/Email/json/with/key/**INSERTKEYHERE**");
  } // make sure to replace "**INSERTKEYHERE**" with your key
  if (digitalRead(BUTTON2) == HIGH)
  {
    openURL("https://maker.ifttt.com/trigger/Call/json/with/key/**INSERTKEYHERE**");
  } // make sure to replace "**INSERTKEYHERE**" with your key
  if (digitalRead(BUTTON3) == HIGH)
  {
    openURL("https://maker.ifttt.com/trigger/SMS/json/with/key/**INSERTKEYHERE**");
  } // make sure to replace "**INSERTKEYHERE**" with your key
  if (digitalRead(BUTTON4) == HIGH)
  {
    openURL("https://maker.ifttt.com/trigger/Tweet/json/with/key/**INSERTKEYHERE**");
  } // make sure to replace "**INSERTKEYHERE**" with your key
}

// opens a url using a get request
void openURL(String url)
{
  if ((WiFi.status() == WL_CONNECTED)) 
  { //Check the current connection status
    HTTPClient http;
    http.begin(url); // Specify the URL
    int httpCode = http.GET(); // Make the request
    if (httpCode > 0) 
    { //Check for the returning code
      String payload = http.getString();
      Serial.println(payload);
    }
    else 
    {
      Serial.println("Error on HTTP request");
    }
    http.end(); //Free the resources
  } 
}
